diff --git a/src/sshmasterconnection.cpp b/src/sshmasterconnection.cpp
index 8b59fe7..424cad2 100644
--- a/src/sshmasterconnection.cpp
+++ b/src/sshmasterconnection.cpp
@@ -1950,260 +1957,263 @@ void SshMasterConnection::channelLoop()
         tv.tv_usec = 500000;
 
         int retval;
-        int maxsock=-1;
-
+        int maxsock = -1;
 
         channelConnectionsMutex.lock();
-        if ( channelConnections.size() <=0 )
+        if (channelConnections.size() <= 0)
         {
             //             x2goDebug<<"no channel connections, waiting\n";
             channelConnectionsMutex.unlock();
-            usleep ( 500 );
+            usleep(500);
             continue;
         }
-        ssh_channel* read_chan=new ssh_channel[channelConnections.size() +1];
-        ssh_channel* out_chan=new ssh_channel[channelConnections.size() +1];
-        read_chan[channelConnections.size() ]=NULL;
+        ssh_channel *read_chan = new ssh_channel[channelConnections.size() + 1];
+        ssh_channel *out_chan = new ssh_channel[channelConnections.size() + 1];
+        read_chan[channelConnections.size()] = NULL;
 
-        FD_ZERO ( &rfds );
+        FD_ZERO(&rfds);
 
-        for ( int i=0; i<channelConnections.size(); ++i )
+        for (int i = 0; i < channelConnections.size(); ++i)
         {
-            int tcpSocket=channelConnections.at ( i ).sock;
-            if ( tcpSocket>0 )
-                FD_SET ( tcpSocket, &rfds );
-            if ( channelConnections.at ( i ).channel==0l )
+            int tcpSocket = channelConnections.at(i).sock;
+            if (tcpSocket > 0)
+                FD_SET(tcpSocket, &rfds);
+            if (channelConnections.at(i).channel == 0l)
             {
-                x2goDebug<<"Creating new channel."<<endl;
-                ssh_channel channel = ssh_channel_new ( my_ssh_session );
+                x2goDebug << "Creating new channel." << endl;
+                ssh_channel channel = ssh_channel_new(my_ssh_session);
 
-                if (!channel) {
-                    QString err = ssh_get_error (my_ssh_session);
+                if (!channel)
+                {
+                    QString err = ssh_get_error(my_ssh_session);
                     /*: Argument in this context will be a function name. */
-                    QString error_msg = tr ("%1 failed.").arg ("ssh_channel_new");
-                    emit ioErr (channelConnections[i].creator, error_msg, err);
+                    QString error_msg = tr("%1 failed.").arg("ssh_channel_new");
+                    emit ioErr(channelConnections[i].creator, error_msg, err);
 
-                    x2goDebug << error_msg.left (error_msg.size () - 1) << ": " << err << endl;
+                    x2goDebug << error_msg.left(error_msg.size() - 1) << ": " << err << endl;
 
                     continue;
                 }
-                x2goDebug<<"New channel:"<<channel<<endl;
-                channelConnections[i].channel=channel;
-                if ( tcpSocket>0 )
+                x2goDebug << "New channel:" << channel << endl;
+                channelConnections[i].channel = channel;
+                if (tcpSocket > 0)
                 {
-                    x2goDebug << "Forwarding parameters: from remote (" << channelConnections.at (i).forwardHost << ":"
-                              << channelConnections.at (i).forwardPort << ") to local ("
-                              << channelConnections.at (i).localHost << ":" << channelConnections.at (i).localPort
+                    x2goDebug << "Forwarding parameters: from remote (" << channelConnections.at(i).forwardHost << ":"
+                              << channelConnections.at(i).forwardPort << ") to local ("
+                              << channelConnections.at(i).localHost << ":" << channelConnections.at(i).localPort
                               << ")";
 
                     /*
                      * Cannot support config file parsing here with pre-0.6.0 libssh versions.
                      * There's just no way to get the inferred host and port values.
                      */
-#if LIBSSH_VERSION_INT >= SSH_VERSION_INT (0, 6, 0)
-                    ssh_session tmp_session = ssh_new ();
+#if LIBSSH_VERSION_INT >= SSH_VERSION_INT(0, 6, 0)
+                    ssh_session tmp_session = ssh_new();
 
-                    if (!tmp_session) {
-                        QString error_msg = tr ("Cannot create SSH session.");
+                    if (!tmp_session)
+                    {
+                        QString error_msg = tr("Cannot create SSH session.");
                         x2goDebug << error_msg;
-                        emit ioErr (channelConnections[i].creator, error_msg, "");
+                        emit ioErr(channelConnections[i].creator, error_msg, "");
                     }
-                    else {
-                        QByteArray tmp_BA = channelConnections.at (i).forwardHost.toLocal8Bit ();
-                        const int tmp_port = channelConnections.at (i).forwardPort;
+                    else
+                    {
+                        QByteArray tmp_BA = channelConnections.at(i).forwardHost.toLocal8Bit();
+                        const int tmp_port = channelConnections.at(i).forwardPort;
 
-                        ssh_options_set (tmp_session, SSH_OPTIONS_HOST, tmp_BA.data ());
+                        ssh_options_set(tmp_session, SSH_OPTIONS_HOST, tmp_BA.data());
 
-                        if (tmp_port) {
-                            ssh_options_set (tmp_session, SSH_OPTIONS_PORT, &tmp_port);
+                        if (tmp_port)
+                        {
+                            ssh_options_set(tmp_session, SSH_OPTIONS_PORT, &tmp_port);
                         }
 
                         /* The host and port might be a shorthand and zero, so fetch the actual data. */
-                        if (ssh_options_parse_config (tmp_session, NULL) < 0) {
+                        if (ssh_options_parse_config(tmp_session, NULL) < 0)
+                        {
                             x2goDebug << "Warning: unable to parse the SSH config file.";
                         }
 
                         unsigned int inferred_port = 0;
-                        ssh_options_get_port (tmp_session, &inferred_port);
+                        ssh_options_get_port(tmp_session, &inferred_port);
                         x2goDebug << "Temporary session port after config file parse: " << inferred_port;
 
                         char *inferred_host = NULL;
-                        ssh_options_get (tmp_session, SSH_OPTIONS_HOST, &inferred_host);
+                        ssh_options_get(tmp_session, SSH_OPTIONS_HOST, &inferred_host);
                         x2goDebug << "Temporary session host after config file parse: " << inferred_host;
 
-                        channelConnections[i].forwardHost = QString (inferred_host);
-                        channelConnections[i].forwardPort = static_cast<int> (inferred_port);
+                        channelConnections[i].forwardHost = QString(inferred_host);
+                        channelConnections[i].forwardPort = static_cast<int>(inferred_port);
 
-                        ssh_string_free_char (inferred_host);
-                        ssh_free (tmp_session);
+                        ssh_string_free_char(inferred_host);
+                        ssh_free(tmp_session);
                     }
 #endif
 
                     {
-                        QByteArray tmp_BA_forward = channelConnections.at (i).forwardHost.toLocal8Bit ();
-                        QByteArray tmp_BA_local = channelConnections.at (i).localHost.toLocal8Bit ();
-
-                        if ( ssh_channel_open_forward ( channel,
-                                                        tmp_BA_forward.data (),
-                                                        channelConnections.at ( i ).forwardPort,
-                                                        tmp_BA_local.data (),
-                                                        channelConnections.at ( i ).localPort ) != SSH_OK )
+                        QByteArray tmp_BA_forward = channelConnections.at(i).forwardHost.toLocal8Bit();
+                        QByteArray tmp_BA_local = channelConnections.at(i).localHost.toLocal8Bit();
+
+                        if (ssh_channel_open_forward(channel,
+                                                     tmp_BA_forward.data(),
+                                                     channelConnections.at(i).forwardPort,
+                                                     tmp_BA_local.data(),
+                                                     channelConnections.at(i).localPort) != SSH_OK)
                         {
-                            QString err=ssh_get_error ( my_ssh_session );
-                            QString errorMsg=tr ( "%1 failed." ).arg ("ssh_channel_open_forward");
-                            emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                            x2goDebug<<errorMsg.left (errorMsg.size () - 1)<<": "<<err<<endl;
+                            QString err = ssh_get_error(my_ssh_session);
+                            QString errorMsg = tr("%1 failed.").arg("ssh_channel_open_forward");
+                            emit ioErr(channelConnections[i].creator, errorMsg, err);
+                            x2goDebug << errorMsg.left(errorMsg.size() - 1) << ": " << err << endl;
                         }
                         else
                         {
-                            x2goDebug<<"New channel forwarded."<<endl;
+                            x2goDebug << "New channel forwarded." << endl;
                         }
                     }
                 }
                 else
                 {
-                    x2goDebug<<"Executing remote: "<<channelConnections.at ( i ).command<<endl;
-                    if ( ssh_channel_open_session ( channel ) !=SSH_OK )
+                    x2goDebug << "Executing remote: " << channelConnections.at(i).command << endl;
+                    if (ssh_channel_open_session(channel) != SSH_OK)
                     {
-                        QString err=ssh_get_error ( my_ssh_session );
-                        QString errorMsg=tr ( "%1 failed." ).arg ("ssh_channel_open_session");
-                        emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                        x2goDebug<<errorMsg.left (errorMsg.size () - 1)<<": "<<err<<endl;
+                        QString err = ssh_get_error(my_ssh_session);
+                        QString errorMsg = tr("%1 failed.").arg("ssh_channel_open_session");
+                        emit ioErr(channelConnections[i].creator, errorMsg, err);
+                        x2goDebug << errorMsg.left(errorMsg.size() - 1) << ": " << err << endl;
                     }
-                    else if ( ssh_channel_request_exec ( channel, channelConnections[i].command.toLatin1() ) != SSH_OK )
+                    else if (ssh_channel_request_exec(channel, channelConnections[i].command.toLatin1()) != SSH_OK)
                     {
-                        QString err=ssh_get_error ( my_ssh_session );
-                        QString errorMsg=tr ( "%1 failed." ).arg ("ssh_channel_request_exec");
-                        emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                        x2goDebug<<errorMsg.left (errorMsg.size () - 1)<<": "<<err<<endl;
+                        QString err = ssh_get_error(my_ssh_session);
+                        QString errorMsg = tr("%1 failed.").arg("ssh_channel_request_exec");
+                        emit ioErr(channelConnections[i].creator, errorMsg, err);
+                        x2goDebug << errorMsg.left(errorMsg.size() - 1) << ": " << err << endl;
                     }
                     else
                     {
-                        x2goDebug<<"New exec channel created."<<endl;
+                        x2goDebug << "New exec channel created." << endl;
                     }
                 }
-
             }
-            read_chan[i]=channelConnections.at ( i ).channel;
-            if ( tcpSocket>maxsock )
-                maxsock=tcpSocket;
+            read_chan[i] = channelConnections.at(i).channel;
+            if (tcpSocket > maxsock)
+                maxsock = tcpSocket;
         }
         channelConnectionsMutex.unlock();
-        retval=ssh_select ( read_chan,out_chan,maxsock+1,&rfds,&tv );
-        delete [] read_chan;
-        delete [] out_chan;
+        retval = ssh_select(read_chan, out_chan, maxsock + 1, &rfds, &tv);
+        delete[] read_chan;
+        delete[] out_chan;
 
-        if ( retval == -1 )
+        if (retval == -1)
         {
-            x2goDebug<<"select() error.";
+            x2goDebug << "select() error.";
             continue;
         }
 
         //         x2goDebug<<"select exited"<<endl;
 
         channelConnectionsMutex.lock();
-        for ( int i=channelConnections.size()-1; i>=0; --i )
+        for (int i = channelConnections.size() - 1; i >= 0; --i)
         {
-            int tcpSocket=channelConnections.at ( i ).sock;
-            ssh_channel channel=channelConnections.at ( i ).channel;
-            if ( channel==0l )
+            int tcpSocket = channelConnections.at(i).sock;
+            ssh_channel channel = channelConnections.at(i).channel;
+            if (channel == 0l)
                 continue;
-            if ( ssh_channel_poll ( channel,1 ) > 0 )
+            if (ssh_channel_poll(channel, 1) > 0)
             {
                 //              x2goDebug<<"read err data from channel\n";
-                nbytes = ssh_channel_read ( channel, buffer, sizeof ( buffer )-1, 1 );
-                emit stdErr ( channelConnections[i].creator, QByteArray ( buffer,nbytes ) );
+                nbytes = ssh_channel_read(channel, buffer, sizeof(buffer) - 1, 1);
+                emit stdErr(channelConnections[i].creator, QByteArray(buffer, nbytes));
                 //              x2goDebug<<nbytes<<" err from channel"<<endl;
             }
-            int rez = ssh_channel_poll ( channel, 0 );
-            if ( rez==SSH_EOF )
+            int rez = ssh_channel_poll(channel, 0);
+            if (rez == SSH_EOF)
             {
-                x2goDebug<<"EOF on channel "<<channel<<"; SshProcess object: "<<channelConnections[i].creator->pid;
+                x2goDebug << "EOF on channel " << channel << "; SshProcess object: " << channelConnections[i].creator->pid;
 
                 //////Finished////////
-                finalize ( i );
+                finalize(i);
                 continue;
             }
-            if ( rez>0 )
+            if (rez > 0)
             {
                 //                  x2goDebug<<"read data from channel "<<channel<<endl;
-                nbytes = ssh_channel_read ( channel, buffer, sizeof ( buffer )-1, 0 );
+                nbytes = ssh_channel_read(channel, buffer, sizeof(buffer) - 1, 0);
                 //                  x2goDebug<<nbytes<<" from channel "<<channel<<endl;
-                if ( nbytes > 0 )
+                if (nbytes > 0)
                 {
-                    if ( tcpSocket>0 )
+                    if (tcpSocket > 0)
                     {
-                        if ( send ( tcpSocket,buffer, nbytes,0 ) != nbytes )
+                        if (send(tcpSocket, buffer, nbytes, 0) != nbytes)
                         {
-                            QString errMsg=tr ( "Error writing to socket." );
-                            x2goDebug<<"Error writing "<<nbytes<<" to TCP socket"<<tcpSocket<<endl;
-                            emit ioErr ( channelConnections[i].creator,errMsg,"" );
-                            finalize ( i );
+                            QString errMsg = tr("Error writing to socket.");
+                            x2goDebug << "Error writing " << nbytes << " to TCP socket" << tcpSocket << endl;
+                            emit ioErr(channelConnections[i].creator, errMsg, "");
+                            finalize(i);
                             continue;
                         }
                         //                      x2goDebug<<"wrote "<<nbytes<<" to tcp socket "<<tcpSocket<<endl;
                     }
                     else
                     {
-                        emit stdOut ( channelConnections[i].creator, QByteArray ( buffer,nbytes ) );
+                        emit stdOut(channelConnections[i].creator, QByteArray(buffer, nbytes));
                     }
                 }
 
-                if ( nbytes < 0 )
+                if (nbytes < 0)
                 {
                     //////ERROR!!!!!////////
-                    QString err=ssh_get_error ( my_ssh_session );
-                    QString errorMsg=tr ( "Error reading channel." );
-                    emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                    x2goDebug<<errorMsg<<" - "<<err<<endl;
-                    finalize ( i );
+                    QString err = ssh_get_error(my_ssh_session);
+                    QString errorMsg = tr("Error reading channel.");
+                    emit ioErr(channelConnections[i].creator, errorMsg, err);
+                    x2goDebug << errorMsg << " - " << err << endl;
+                    finalize(i);
                     continue;
                 }
 
-                if ( ssh_channel_is_eof ( channel ) )
+                if (ssh_channel_is_eof(channel))
                 {
-                    x2goDebug<<"EOF on channel "<<channel<<"; SshProcess object: "<<channelConnections[i].creator->pid;
+                    x2goDebug << "EOF on channel " << channel << "; SshProcess object: " << channelConnections[i].creator->pid;
 
                     //////Finished////////
-                    finalize ( i );
+                    finalize(i);
                     continue;
                 }
             }
-            if ( tcpSocket<=0 )
+            if (tcpSocket <= 0)
             {
                 continue;
             }
-            if ( FD_ISSET ( tcpSocket,&rfds ) )
+            if (FD_ISSET(tcpSocket, &rfds))
             {
-                nbytes = recv ( tcpSocket, buffer, sizeof ( buffer )-1,0 );
+                nbytes = recv(tcpSocket, buffer, sizeof(buffer) - 1, 0);
                 //                  x2goDebug<<nbytes<<" bytes from tcp socket "<<tcpSocket<<endl;
-                if ( nbytes > 0 )
+                if (nbytes > 0)
                 {
-                    if ( ssh_channel_write ( channel, buffer, nbytes ) !=nbytes )
+                    if (ssh_channel_write(channel, buffer, nbytes) != nbytes)
                     {
-                        QString err=ssh_get_error ( my_ssh_session );
-                        QString errorMsg=tr ( "%1 failed." ).arg ("ssh_channel_write");
-                        emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                        x2goDebug<<errorMsg.left (errorMsg.size () - 1)<<": "<<err<<endl;
-                        finalize ( i );
+                        QString err = ssh_get_error(my_ssh_session);
+                        QString errorMsg = tr("%1 failed.").arg("ssh_channel_write");
+                        emit ioErr(channelConnections[i].creator, errorMsg, err);
+                        x2goDebug << errorMsg.left(errorMsg.size() - 1) << ": " << err << endl;
+                        finalize(i);
                         continue;
                     }
                     //                      x2goDebug<<nbytes<<" bytes wrote to channel"<<channel<<endl;
                 }
-                if ( nbytes < 0 )
+                if (nbytes < 0)
                 {
                     //////ERROR!!!!!////////
-                    QString err="";
-                    QString errorMsg=tr ( "Error reading from TCP socket." );
-                    emit ioErr ( channelConnections[i].creator, errorMsg, err );
-                    x2goDebug<<errorMsg<<" - "<<err<<endl;
-                    finalize ( i );
+                    QString err = "";
+                    QString errorMsg = tr("Error reading from TCP socket.");
+                    emit ioErr(channelConnections[i].creator, errorMsg, err);
+                    x2goDebug << errorMsg << " - " << err << endl;
+                    finalize(i);
                     continue;
                 }
-                if ( nbytes==0 )
+                if (nbytes == 0)
                 {
-                    x2goDebug<<"Socket "<<tcpSocket<<" closed."<<endl;
-                    finalize ( i );
+                    x2goDebug << "Socket " << tcpSocket << " closed." << endl;
+                    finalize(i);
                     continue;
                 }
             }
@@ -2212,34 +2222,30 @@ void SshMasterConnection::channelLoop()
     }
 }
 
-void SshMasterConnection::finalize ( int item )
+void SshMasterConnection::finalize(int item)
 {
-    int tcpSocket=channelConnections.at ( item ).sock;
-    ssh_channel channel=channelConnections.at ( item ).channel;
-    if ( channel )
+    int tcpSocket = channelConnections.at(item).sock;
+    ssh_channel channel = channelConnections.at(item).channel;
+    if (channel)
     {
-        ssh_channel_send_eof ( channel );
-        x2goDebug<<"EOF sent.";
-        ssh_channel_close ( channel );
-        x2goDebug<<"Channel closed.";
-        ssh_channel_free ( channel );
+        ssh_channel_send_eof(channel);
+        x2goDebug << "EOF sent.";
+        ssh_channel_close(channel);
+        x2goDebug << "Channel closed.";
+        ssh_channel_free(channel);
     }
-    if ( tcpSocket>0 )
+    if (tcpSocket > 0)
     {
 #ifndef Q_OS_WIN
         shutdown(tcpSocket, SHUT_RDWR);
-        close ( tcpSocket );
+        close(tcpSocket);
 #else
         shutdown(tcpSocket, SD_BOTH);
-        closesocket ( tcpSocket );
+        closesocket(tcpSocket);
 #endif
     }
-    SshProcess* proc=channelConnections[item].creator;
-    QString uuid=channelConnections[item].uuid;
-    channelConnections.removeAt ( item );
-    emit channelClosed ( proc, uuid );
+    SshProcess *proc = channelConnections[item].creator;
+    QString uuid = channelConnections[item].uuid;
+    channelConnections.removeAt(item);
+    emit channelClosed(proc, uuid);
 }
-
-
-
-
diff --git a/src/sshmasterconnection.h b/src/sshmasterconnection.h
index ffb853b..c7883be 100644
--- a/src/sshmasterconnection.h
+++ b/src/sshmasterconnection.h
@@ -27,11 +27,13 @@
 #include <QTcpSocket>
 #include <QNetworkProxy>
 
-
-#define PROPERTY(TYPE,NAME)  private: TYPE NAME; \
-public: TYPE get_##NAME(){return NAME;} \
-void set_##NAME(TYPE VAL){NAME=VAL;}
-
+#define PROPERTY(TYPE, NAME)           \
+private:                               \
+    TYPE NAME;                         \
+                                       \
+public:                                \
+    TYPE get_##NAME() { return NAME; } \
+    void set_##NAME(TYPE VAL) { NAME = VAL; }
 
 class ONMainWindow;
 class SshProcess;
@@ -39,16 +41,16 @@ struct ChannelConnection
 {
     ssh_channel channel;
     int sock;
-    SshProcess* creator;
+    SshProcess *creator;
     int forwardPort;
     int localPort;
     QString forwardHost;
     QString localHost;
     QString command;
     QString uuid;
-    bool operator==(ChannelConnection& t)
+    bool operator==(ChannelConnection &t)
     {
-        return (channel==t.channel);
+        return (channel == t.channel);
     }
 };
 
@@ -57,25 +59,30 @@ struct ReverseTunnelRequest
     uint localPort;
     uint forwardPort;
     QString localHost;
-    SshProcess* creator;
+    SshProcess *creator;
     bool listen;
 };
 
 struct CopyRequest
 {
-    SshProcess* creator;
+    SshProcess *creator;
     QString src;
     QString dst;
 };
 
-class SshMasterConnection: public QThread
+class SshMasterConnection : public QThread
 {
     Q_OBJECT
     PROPERTY(bool, kerberosDelegation)
 public:
-    enum ProxyType {PROXYSSH, PROXYHTTP};
+    enum ProxyType
+    {
+        PROXYSSH,
+        PROXYHTTP
+    };
 
-    enum passphrase_types {
+    enum passphrase_types
+    {
         PASSPHRASE_PRIVKEY,
         PASSPHRASE_CHALLENGE,
         PASSPHRASE_PASSWORD,
@@ -83,28 +90,28 @@ public:
     };
 
     void run();
-    SshMasterConnection(QObject* parent, QString host, int port, bool acceptUnknownServers, QString user,
-                        QString pass, QString key, bool autologin, bool krblogin=false,
-                        bool useproxy=false, ProxyType type=PROXYSSH, QString proxyserver=QString::null, quint16 proxyport=0,
-                        QString proxylogin=QString::null, QString proxypassword=QString::null, QString proxyKey=QString::null,
-                        bool proxyAutologin=false, bool proxyKrbLogin=false);
+    SshMasterConnection(QObject *parent, QString host, int port, bool acceptUnknownServers, QString user,
+                        QString pass, QString key, bool autologin, bool krblogin = false,
+                        bool useproxy = false, ProxyType type = PROXYSSH, QString proxyserver = QString::null, quint16 proxyport = 0,
+                        QString proxylogin = QString::null, QString proxypassword = QString::null, QString proxyKey = QString::null,
+                        bool proxyAutologin = false, bool proxyKrbLogin = false);
     ~SshMasterConnection();
-    void addChannelConnection(SshProcess* creator, int sock, QString forwardHost,
-                              int forwardPort, QString localHost, int localPort, void* channel=0l);
-    void addChannelConnection(SshProcess* creator, QString uuid, QString cmd);
-    void addCopyRequest(SshProcess* creator, QString src, QString dst);
+    void addChannelConnection(SshProcess *creator, int sock, QString forwardHost,
+                              int forwardPort, QString localHost, int localPort, void *channel = 0l);
+    void addChannelConnection(SshProcess *creator, QString uuid, QString cmd);
+    void addCopyRequest(SshProcess *creator, QString src, QString dst);
     void writeKnownHosts(bool);
     void setKeyPhrase(QString);
 
-    int executeCommand(const QString& command, QObject* receiver=0, const char* slotFinished=0, bool overridePath=true);
-    int startTunnel(const QString& forwardHost, uint forwardPort, const QString& localHost,
-                    uint localPort, bool reverse=false, QObject* receiver=0, const char* slotTunnelOk=0, const char* slotFinished=0);
-    int copyFile(const QString& src, const QString dst, QObject* receiver=0, const char* slotFinished=0);
+    int executeCommand(const QString &command, QObject *receiver = 0, const char *slotFinished = 0, bool overridePath = true);
+    int startTunnel(const QString &forwardHost, uint forwardPort, const QString &localHost,
+                    uint localPort, bool reverse = false, QObject *receiver = 0, const char *slotTunnelOk = 0, const char *slotFinished = 0);
+    int copyFile(const QString &src, const QString dst, QObject *receiver = 0, const char *slotFinished = 0);
     QString getSourceFile(int pid);
 
     void setAcceptUnknownServers(bool accept)
     {
-        acceptUnknownServers=accept;
+        acceptUnknownServers = accept;
     }
     QString getHost()
     {
@@ -136,7 +143,7 @@ private:
     void channelLoop();
     void finalize(int arg1);
     void copy();
-    int serverAuth(QString& errorMsg);
+    int serverAuth(QString &errorMsg);
     void setVerficationCode(QString code);
     void checkReverseTunnelConnections();
     void addReverseTunnelConnections();
@@ -146,19 +153,18 @@ private:
 
 private slots:
 
-    void slotSshProxyServerAuthError ( int,QString, SshMasterConnection* );
-    void slotSshProxyServerAuthAborted ();
-    void slotSshProxyUserAuthError ( QString );
-    void slotSshProxyConnectionError ( QString,QString );
-
+    void slotSshProxyServerAuthError(int, QString, SshMasterConnection *);
+    void slotSshProxyServerAuthAborted();
+    void slotSshProxyUserAuthError(QString);
+    void slotSshProxyConnectionError(QString, QString);
 
     void slotSshProxyConnectionOk();
     void slotSshProxyTunnelOk(int);
-    void slotSshProxyTunnelFailed(bool result,  QString output,
+    void slotSshProxyTunnelFailed(bool result, QString output,
                                   int);
-    void slotSshProxyInteractionStart ( SshMasterConnection* connection, QString prompt );
-    void slotSshProxyInteractionUpdate ( SshMasterConnection* connection, QString output );
-    void slotSshProxyInteractionFinish ( SshMasterConnection* connection);
+    void slotSshProxyInteractionStart(SshMasterConnection *connection, QString prompt);
+    void slotSshProxyInteractionUpdate(SshMasterConnection *connection, QString output);
+    void slotSshProxyInteractionFinish(SshMasterConnection *connection);
 
 public slots:
     void interactionTextEnter(QString text);
@@ -180,7 +186,7 @@ private:
     bool writeHostKey;
     bool writeHostKeyReady;
     int nextPid;
-    QList<SshProcess*> processes;
+    QList<SshProcess *> processes;
 
     QString keyPhrase;
     bool keyPhraseReady;
@@ -205,12 +211,12 @@ private:
     bool disconnectSessionFlag;
     int localProxyPort;
     bool acceptUnknownServers;
-    ONMainWindow* mainWnd;
+    ONMainWindow *mainWnd;
     bool kerberos;
     QString sshProcErrString;
     QTcpSocket *tcpProxySocket;
     QNetworkProxy *tcpNetworkProxy;
-    SshMasterConnection* sshProxy;
+    SshMasterConnection *sshProxy;
     bool sshProxyReady;
     bool breakLoop;
     bool loginCheck;
@@ -221,30 +227,29 @@ private:
     static const QString challenge_auth_code_prompts_[];
 
 signals:
-    void stdErr(SshProcess* caller, QByteArray data);
-    void stdOut(SshProcess* caller, QByteArray data);
-    void ioErr(SshProcess* caller, QString error, QString lastSessionError);
-    void copyErr(SshProcess* caller, QString error, QString lastSessionError);
-    void copyOk(SshProcess* caller);
-    void channelClosed(SshProcess* caller, QString uuid);
-    void reverseTunnelOk(SshProcess* caller);
-    void reverseTunnelFailed(SshProcess* caller, QString error);
+    void stdErr(SshProcess *caller, QByteArray data);
+    void stdOut(SshProcess *caller, QByteArray data);
+    void ioErr(SshProcess *caller, QString error, QString lastSessionError);
+    void copyErr(SshProcess *caller, QString error, QString lastSessionError);
+    void copyOk(SshProcess *caller);
+    void channelClosed(SshProcess *caller, QString uuid);
+    void reverseTunnelOk(SshProcess *caller);
+    void reverseTunnelFailed(SshProcess *caller, QString error);
 
     void connectionError(QString message, QString lastSessionError);
-    void serverAuthError(int errCode, QString lastSessionError, SshMasterConnection*);
+    void serverAuthError(int errCode, QString lastSessionError, SshMasterConnection *);
     void serverAuthAborted();
     void userAuthError(QString error);
 
-    void connectionOk( QString host);
+    void connectionOk(QString host);
 
-    void needPassPhrase(SshMasterConnection*, SshMasterConnection::passphrase_types);
-    void needChallengeResponse(SshMasterConnection*, QString Challenge);
-    void startInteraction(SshMasterConnection*, QString prompt);
-    void finishInteraction(SshMasterConnection*);
-    void updateInteraction(SshMasterConnection*, QString output);
+    void needPassPhrase(SshMasterConnection *, SshMasterConnection::passphrase_types);
+    void needChallengeResponse(SshMasterConnection *, QString Challenge);
+    void startInteraction(SshMasterConnection *, QString prompt);
+    void finishInteraction(SshMasterConnection *);
+    void updateInteraction(SshMasterConnection *, QString output);
 };
 
-Q_DECLARE_METATYPE (SshMasterConnection::passphrase_types)
+Q_DECLARE_METATYPE(SshMasterConnection::passphrase_types)
 
 #endif // SSHMASTERCONNECTION_H
-
-- 
2.17.1

